% RNA - TD 3 : Discrimination lineaire
% Date : 3 Mars 2003
% Auteurs : Soizic Geslin - Maxime Chambreuil

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EN ENTREE

% nbitemax : Nombre maximal d'iteration
% pas : Pas de l'iteration
% X : matrice 2*n lignes, 3 colonnes (3eme colonne = biais)
% Y : vecteur 2*n lignes , -1 ou 1 selon la classe
% methode : 1 = Perceptron
%           2 = Adaline
%           3 = Neurone formel

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EN SORTIE

% W : coefficient de la droite de discrimination
% cout : cout 

function [W,cout] = discrimination(nbitemax,pas,X,Y,methode)

k=0;
cout = 1;
W=ones(size(X,2),1);

while((cout>0) & (k<nbitemax))
        k = k+1;
        ind = randperm(length(X));
        
        for i = 1:length(X)
	   % Perceptron
           if (methode == 1)
	       %On reprend l'algo du gradient
               Dir = (sign(X(ind(i),:)*W)-Y(ind(i)))*X(ind(i),:);
           end

	   % Adaline
           if (methode == 2)
	       % c'est la mm chose mais avec psi'=1
               
	       Dir = ( X(ind(i),:)*W - Y(ind(i)) ) * X(ind(i),:);
           end
	
	   % Neurone formel
           if (methode == 3)
	       %c'est la mm chose mais avec psi=th tangente hyperbolique
	       %th=sh/ch
	       %th'=(ch*ch - sh*sh)/(ch*ch)=1-th*th
               
	       Dir = ( tanh(X(ind(i),:)*W) - Y(ind(i)) ) * (1 - tanh( X(ind(i),:)*W )'* tanh( X(ind(i),:)*W )) * X(ind(i),:);
           end
           W = W-pas*Dir';
        end          
        cout = sum(abs(sign(X*W)-Y));
end
fprintf('Nombre d`iteration : %d\n',k); 

